
require 'fileutils'
require 'erb'

class ContextItem
  include FileUtils

  def initialize(config, item)
    @config = config
    @item = item
  end

  def name
    return @item.name
  end

  def prefix
    path = @item.prefix(@config.install_dir)
    if not test(?d, path) then
      mkdir_p path
    end
    return path
  end

end

class Context < ContextItem
  attr_reader :deps
  
  def initialize(config, item)
    super(config, item)
    @deps = item.dep_items.collect do |dep|
      ContextItem.new(config, dep)
    end
  end

  def actions
    @config.actions.each do |template|
      yield instantiate(template)
    end      
  end

 
  def instantiate(template)
    t = ERB.new(template)
    return t.result(binding())
  end
end
